package premigrations

import (
	"github.com/docker/distribution/registry/datastore/migrations"
	migrate "github.com/rubenv/sql-migrate"
)

func init() {
	m := &migrations.Migration{
		Migration: &migrate.Migration{
			Id: "20250602110230_create_import_stats_table",
			Up: []string{
				`CREATE TABLE IF NOT EXISTS import_statistics (
					id bigint NOT NULL GENERATED BY DEFAULT AS IDENTITY,
					created_at timestamp WITH time zone NOT NULL DEFAULT now(),
					started_at timestamp WITH time zone NOT NULL,
					finished_at timestamp WITH time zone,
					pre_import boolean DEFAULT FALSE,
					pre_import_started_at timestamp WITH time zone,
					pre_import_finished_at timestamp WITH time zone,
					pre_import_error text,
					tag_import boolean DEFAULT FALSE,
					tag_import_started_at timestamp WITH time zone,
					tag_import_finished_at timestamp WITH time zone,
					tag_import_error text,
					blob_import boolean DEFAULT FALSE,
					blob_import_started_at timestamp WITH time zone,
					blob_import_finished_at timestamp WITH time zone,
					blob_import_error text,
					repositories_count bigint DEFAULT 0 NOT NULL,
					tags_count bigint DEFAULT 0 NOT NULL,
					manifests_count bigint DEFAULT 0 NOT NULL,
					blobs_count bigint DEFAULT 0 NOT NULL,
					blobs_size_bytes bigint DEFAULT 0 NOT NULL,
					storage_driver text,
					CONSTRAINT pk_import_statistics PRIMARY KEY (id)
				)`,
			},
			Down: []string{
				"DROP TABLE IF EXISTS import_statistics CASCADE",
			},
		},
	}
	migrations.AppendPreMigration(m)
}
